//
//  OpenCombineTestTests.swift
//  OpenCombineTestTests
//
//  Created by Alberto Penas Amor on 1/2/23.
//

import XCTest
import OpenCombine
import OpenCombineDispatch
@testable import OpenCombineTest

class OpenCombineTestTests: XCTestCase {
    var subscriptions: Set<AnyCancellable> = .init()
    
    func testExample() throws {
        let scheduler = DispatchQueue.OCombine(DispatchQueue.main)
        let expectation = self.expectation(description: #function)
        var result: (Int, Int)?
        
        let firstPublisher = Just(1)
            .debounce(for: .milliseconds(600), scheduler: scheduler)
        .eraseToAnyPublisher()
        let secondPublisher = Just(2)
            .debounce(for: .milliseconds(600), scheduler: scheduler)
            .eraseToAnyPublisher()
        Publishers.Zip(firstPublisher, secondPublisher)
            .eraseToAnyPublisher()
            .sink(receiveValue: { result = ($0.0, $0.1); expectation.fulfill()})
            .store(in: &subscriptions)
        
        wait(for: [expectation], timeout: 2)
        
        XCTAssertEqual(result?.0, 1)
        XCTAssertEqual(result?.1, 2)
    }
}
